/*programma per la gestione dei voli*/
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<ctype.h>
#define NMAX_VOLI 14
#define NCOD 6
#define NDEST 25
#define file_dati_voli "dativoli12.dat"

typedef char Tipo_codice_volo[NCOD];
typedef char Tipo_destinazione[NDEST];
typedef struct { int ora;
                int minuti;
               }Nuovo_or;

typedef struct  {Tipo_codice_volo codice;
                              Nuovo_or orario;
                              int posti_liberi;
                              Tipo_destinazione dest;
                             }Rec_volo;

 typedef struct {Rec_volo elenco_voli;
                 }Tabel[NMAX_VOLI];

/*int s;*/ /*variabile per restituire il carattere scelto nel menu*/

/*Tabel tab; *//*tab variabile per accedere all'array di NMAX_VOLI di struct */

/*prototipi delle funzioni che useremo*/
void carica_tabella(FILE *f,Tabel tab);
void salva_tabella(FILE *f,Tabel tab);
int indice(Tipo_codice_volo,Tabel tab  );
void aggiungi_volo(FILE *f,Tabel tab );
void elimina_volo(FILE *f,Tipo_codice_volo,Tabel tab );
void stampa_tabella(FILE *f,Tabel tab);
void stampa_volo(FILE *f, Tipo_codice_volo, Tabel tab);
void aggiorna_posti(FILE *f, Tipo_codice_volo , int,Tabel tab );
void aggiorna_orario(FILE *f,Tipo_codice_volo , Nuovo_or,Tabel tab);
int menu(int); void iniz(Tabel tab);
void conferma_salvataggio();

int main(void)
{
FILE *fp;
Tabel tab ;
char car;
int k,i;
char ch;
char scelta;
Nuovo_or nuovo_orario;
Tipo_codice_volo volo;
Rec_volo nuovo_volo;
 while(1)
 {
 scelta=menu(0);
  {
  switch(scelta)
  {
   case 'S': {stampa_tabella(fp,tab);break; }
   case 'V':{carica_tabella(fp,tab);printf("\nstampa del volo: inserite il codice del volo : ");
             scanf("\n%s",volo);
             stampa_volo(fp,volo,tab);break;}

   case 'A': {aggiungi_volo(fp,tab);break;}
   case 'E': {printf("\neliminazione del volo: inserite il codice del volo: ");
            scanf("\n%s",volo);
            elimina_volo(fp,volo,tab);
            break;}

  case 'L': {carica_tabella(fp,tab);break; }
  case 'P': { printf("aggiorna numero posti prenotati: inserite codice del volo : ");
            scanf("\n%s",volo);
            i=indice(volo,tab);
            if(i!=-1)
             {
             printf("\ni posti liberi nel volo di codice %s : %d \n",volo, tab[i].elenco_voli.posti_liberi);
             printf("\nnumero di posti prenotati (negativo se si liberano) ");
	     scanf("\n%d",&k);
             aggiorna_posti(fp,volo,k,tab);
             }
            break;}

   case 'O': {printf("\naggiornamento orario di partenza: inserite codice del volo: ");
             scanf("%s",volo);
             i=indice(volo,tab);
             if(i!=-1)
             {
             printf("\nnuovo orario: ");
             scanf("\n%d%c%d",&nuovo_orario.ora,&ch,&nuovo_orario.minuti);
             aggiorna_orario(fp,volo,nuovo_orario,tab);
             }
             break; }
    case 'U': exit(0);
   }
  }
 }
scanf("\n%c", &car);
return (0);
}

int menu(int s)
{
 printf("\n************************************************");
 printf("\noperazioni possibili :\n");
 printf("\nS : stampa l'elenco dei voli");
 printf("\nV : stampa un volo dall'elenco");
 printf("\nA : aggiunge un nuovo volo all/'elenco");
 printf("\nE : sopprime un volo");
 printf("\nP : aggiorna il numero di posti");
 printf("\nO : aggiorna l'orario di partenza");
 printf("\nU : uscita dal programma");
 printf("\n\nimmettere operazione da compiere: ");
  s=toupper(getchar());
   while((s!='S')&&(s!='V')&&(s!='A')&&(s!='E')&&(s!='P')&&(s!='O')&&(s!='R')&&(s!='F')&&(s!='U'))
    s=toupper(getchar());
     printf("\n%c\n",s);
 return(s);
}


void iniz(Tabel tab)  /*inizializzazione*/
{
register int t,i;
for(t=0;t<NMAX_VOLI;t++) strcpy(tab[t].elenco_voli.codice,"");
for(t=0;t<NMAX_VOLI;t++) tab[t].elenco_voli.orario.ora='\0';
for(t=0;t<NMAX_VOLI;t++) tab[t].elenco_voli.orario.minuti='\0';
for(t=0;t<NMAX_VOLI;t++) tab[t].elenco_voli.posti_liberi='\0';
for(t=0;t<NMAX_VOLI;t++) strcpy(tab[t].elenco_voli.dest,"");

}

/*funzione di caricamento file da memoria secondaria*/


void carica_tabella(FILE *f,Tabel tab)
{
int i;
 iniz(tab);
  if((f=fopen(file_dati_voli,"rb"))==NULL)
   {fprintf(stderr,"\nImpossibile aprire il file");
   return;
   }
  for(i=0;i<NMAX_VOLI;i++)
   {
     if(fread(&tab[i],sizeof(Rec_volo),1,f)!=1);
       {
       if(feof(f))
       { fclose(f);
        fprintf(stderr,"Errore di lettura del file\n");
        break;
        }
      }
   }
 fclose(f);
}


void salva_tabella(FILE *f,Tabel tab)
{
/*FILE *f;*/

int h;
 if((f=fopen(file_dati_voli,"wb"))=='\0')
  {
  fprintf(stderr,"impossibile aprire il file\n");
  return;
  }
  else
   for(h=0;h<NMAX_VOLI;h++)
    if(fwrite(&tab[h],sizeof(Rec_volo),1,f)!=1)
     fprintf(stderr,"errore di scrittura\n");
fclose(f);
}

/*funzione di ricerca*/
int indice(Tipo_codice_volo volo,Tabel tab)
{
/*restituisce l'indice della tabella che ha codice uguale a volo; se
l'elemento non e' presente nella tabella la funzione restituisce -1*/
int h=NMAX_VOLI-1; /*indice per la scansione della tabella*/
int trovato=0;

 while((h>=0)&&(!trovato))
  {
  if(!strcmp(tab[h].elenco_voli.codice,volo))
  trovato=1; /*volo e'stato trovato*/
  else h=h-1;/*preparazione alla ricerca del prossimo elemento*/
  }

/*N.B. se volo non e' stato trovato, allora h=-1, altrimenti h
contiene l'indice dell'elemento dell'array tab[h].elenco_voli, in
cui c'e' volo*/
if(h==-1){printf("\nvolo non trovato\n");}
return(h); /*trasmissione del risultato all'unita' chiamante*/
}

void aggiungi_volo(FILE *f,Tabel tab)
{
/*aggiunge un volo nella tabella: */

char space;
char buffer[NDEST];
int p,i;
char cod[NCOD];
char dati;
    iniz(tab);
    carica_tabella(f,tab);
    for(i=0;i<NMAX_VOLI;i++)
    {
    if(!strcmp(tab[i].elenco_voli.codice,""))
     break;
    }
     if(i>=NMAX_VOLI)
      {printf("\nTabella piena\n"); return;}
      else
      {
       p=i;
       printf("\naggiunta volo ...%d ",p+1 );
       printf("\ninserite il codice volo: ");
       scanf("%s",tab[p].elenco_voli.codice);
       printf("Orario di partenza (ore minuti es. 20 15) :");
       scanf("%d%c%d",&tab[p].elenco_voli.orario.ora,&space,&tab[p].elenco_voli.orario.minuti);
       printf("\ninserite il n. di posti liberi: ");
       scanf("%d",&tab[p].elenco_voli.posti_liberi);
       printf("\ndestinazione: ");
       scanf("%s",tab[p].elenco_voli.dest);
        printf("\nI dati inseriti sono corretti (s/n)\n");
        scanf("\n%c",&dati);
        dati=toupper(dati);
         if(dati=='S')
         salva_tabella(f,tab);
      }
      
 } /*fine aggiungi_volo*/

 void elimina_volo(FILE *f,Tipo_codice_volo volo,Tabel tab)
 {
 int i,k;
 char car; /* usato per il controllo dell'eliminazione vale s od n*/
 iniz(tab);
 carica_tabella(f,tab);
 i=indice(volo,tab);
 if(i==-1)
  {printf("\ncodice volo non in elenco\n");
   return;}
  else
   {
    printf("\nstai eliminando il volo di codice %s s/n ", volo);
    scanf("\n%c",&car);
    car=toupper(car);
   }
    if(car=='S')
     {
     printf("\n%c\n",car);
     strcpy(tab[i].elenco_voli.codice,"");
     tab[i].elenco_voli.orario.ora='\0';
     tab[i].elenco_voli.orario.minuti='\0';
     tab[i].elenco_voli.posti_liberi='\0';
     strcpy(tab[i].elenco_voli.dest,"");
     salva_tabella(f,tab);
    }
}/*fine funzione elimina_volo*/

void stampa_tabella(FILE *f,Tabel tab)
 {
 int h;
 int cont_voli=0;
 char car;
 iniz(tab);
 carica_tabella(f,tab);
 printf("\nstampa dati sui voli");
 printf("\n..................................................\n");
 for(h=0; h<NMAX_VOLI;h++)
  {
   if(strcmp(tab[h].elenco_voli.codice,""))
    {
    printf("\nCodice volo: %s",tab[h].elenco_voli.codice);
    printf("   Orario di partenza:  %2d %2d ",tab[h].elenco_voli.orario.ora,tab[h].elenco_voli.orario.minuti);
    printf("\nPosti liberi: %3d",tab[h].elenco_voli.posti_liberi);
    printf("   Destinazione: %s ",tab[h].elenco_voli.dest);
    cont_voli++;
     if((cont_voli%5)==0)
     {
     printf("\nPremere un carattere per la videata successiva\n");
     scanf("\n%c",&car);
     }
     
    }/*end if*/
  }
 }/*fine stampa_tabella*/

void stampa_volo(FILE *f,Tipo_codice_volo cod,Tabel tab)
{
/*cerca il codice di codice cod e lo stampa su video*/
int i;
iniz(tab);
/*caricamento della tabella da disco */

carica_tabella(f,tab);
i=indice(cod,tab);
  if(i==-1) /* se il volo non e' nella tabella*/
   {printf("\n%s",cod," :Codice volo non trovato");return;}
   else
   {
    printf("\n___________________________________________________\n");
    printf("\nCodice volo:  %s",tab[i].elenco_voli.codice);
    printf("    Orario di partenza:   %2d % 2d",tab[i].elenco_voli.orario.ora, tab[i].elenco_voli.orario.minuti);
    printf("\nPosti liberi:  %3d",tab[i].elenco_voli.posti_liberi);
    printf("    Destinazione: %s ",tab[i].elenco_voli.dest);
    printf("\n___________________________________________________\n");
   }

} /*fine stampa_volo*/


void aggiorna_posti(FILE *f, Tipo_codice_volo volo, int k,Tabel tab)
{
int i;
char car;
carica_tabella(f,tab);
i=indice(volo,tab);
  if(i==-1)
  {
   printf("\n%s ", volo,": codice volo non trovato");
   return;}
 else
 {
  if(tab[i].elenco_voli.posti_liberi<k)
  {
   printf("\nposti insufficienti sul volo %s", volo);
   return;
  }
  else
   {
   printf("\nposti liberi nel volo di codice %s sono %d \n",volo, tab[i].elenco_voli.posti_liberi);
   tab[i].elenco_voli.posti_liberi= tab[i].elenco_voli.posti_liberi - k;

   }
   
 printf("\nsalviamo le modifiche apportate? (s/n)\n");
 scanf("\n%c",&car);
 car=toupper(car);
 if(car=='S')
  salva_tabella(f,tab);
 }

} /*fine aggiorna_posti*/

void aggiorna_orario(FILE *f, Tipo_codice_volo volo,Nuovo_or nuovo_orario,Tabel tab)
{
int i;
char car;
carica_tabella(f,tab);
i=indice(volo,tab);
  if(i==-1)
   {printf("\n%s ", volo," : codice volo non trovato"); return;}
   else
   {
   {
    printf("\nIl vecchio orario di partenza era:   %2d % 2d",tab[i].elenco_voli.orario.ora, tab[i].elenco_voli.orario.minuti);
    tab[i].elenco_voli.orario=nuovo_orario;
   }
printf("\nsalviamo le modifiche d'orario al vodo di codice %s (s/n) ",volo);
scanf("\n%c",&car);
car=toupper(car);
if(car=='S')
salva_tabella(f,tab);
}
} /*fine aggiorna_orario*/


